委托系列学习之委托基础
=====================

委托概念
--------
百度百科：
> 委托是一个类，它定义了方法的类型，使得可以将方法当作另一个方法的参数来进行传递。
> 这种将方法动态地赋给参数的做法，可以避免在程序中大量使用If-Else(Switch)语句，同时使得程序具有更好的可扩展性。

数据结构本质：

> 委托和类一样，是一种用户自定义的引用类型。
 委托和类同级，类表示数据集合，委托表示对一个或多个方法的引用。
 储存的是一系列具有相同参数和返回类型方法的地址列表，调用委托时，此委托列表的所有方法都将被执行。 

作用理解：

> 委托是.net中函数回调机制的实现方式。
> 是函数指针在面向对象中的封装，是面向对象的、类型安全的、可靠的。

特点：
* 面向对象
* 类型安全
* 可靠



